#include "lib_xp.h"

//////////////////////////////////////////////////////////////////////////

XParticlesLibrary *lib_xp = NULL;

static XParticlesLibrary *CheckXPLib(LONG offset)
{
	return (XParticlesLibrary*)CheckLib(LIBRARY_XPARTICLES, offset, (C4DLibrary**)&lib_xp);
}

#define XPLibCall(b) 		XParticlesLibrary *lib = CheckXPLib(LIBOFFSET(XParticlesLibrary, b)); \
															if (!lib || !lib->b) return; \
															(lib->b)

#define XPLibCallR(a,b)  XParticlesLibrary *lib = CheckXPLib(LIBOFFSET(XParticlesLibrary, b)); \
															if (!lib || !lib->b) return a; \
															return (lib->b)

//////////////////////////////////////////////////////////////////////////

LONG XPEmitterObject::GetParticleCount() { XPLibCallR(0, xpemitGetParticleCount)(this); }
LONG XPEmitterObject::GetAliveCount() { XPLibCallR(0, xpemitGetAliveCount)(this); }
LONG XPEmitterObject::GetDeadCount() { XPLibCallR(0, xpemitGetDeadCount)(this); }
xparticles_lib::XParticle *XPEmitterObject::GetParticle(LONG index) { XPLibCallR(NULL, xpemitGetParticle)(this, index); }
xparticles_lib::XParticle *XPEmitterObject::CreateParticle() { XPLibCallR(NULL, xpemitCreateParticle)(this); }
BOOL XPEmitterObject::SetParticleCount(LONG count) { XPLibCallR(FALSE, xpemitSetParticleCount)(this, count); }
LONG XPEmitterObject::GetFlags() { XPLibCallR(0, xpemitGetFlags)(this); }
void XPEmitterObject::SetFlags(LONG flags) { XPLibCall(xpemitSetFlags)(this, flags); }
xparticles_lib::XParticle *XPEmitterObject::GetFirstAlive() { XPLibCallR(NULL, xpemitGetFirstAlive)(this); }
xparticles_lib::XParticle *XPEmitterObject::GetLastAlive() { XPLibCallR(NULL, xpemitGetLastAlive)(this); }
LONG XPEmitterObject::GetMaxCount() { XPLibCallR(0, xpemitGetMaxCount)(this); }
BOOL XPEmitterObject::SetMaxCount(LONG count) { XPLibCallR(FALSE, xpemitSetMaxCount)(this, count); }

void XPVideoPost::SkipRender()  { XPLibCall(xpvpSkipRender)(this); }

Vector xparticles_lib::XParticle::GetPosition() { XPLibCallR(Vector(), xppartGetPosition)(this); }
Vector xparticles_lib::XParticle::GetVelocity() { XPLibCallR(Vector(), xppartGetVelocity)(this); }
Real xparticles_lib::XParticle::GetTime() { XPLibCallR(0.0, xppartGetTime)(this); }
Real xparticles_lib::XParticle::GetLife() { XPLibCallR(0.0, xppartGetLife)(this); }
Vector xparticles_lib::XParticle::GetColor() { XPLibCallR(Vector(), xppartGetColor)(this); }
Real xparticles_lib::XParticle::GetRadius() { XPLibCallR(0.0, xppartGetRadius)(this); }
Real xparticles_lib::XParticle::GetMass() { XPLibCallR(0.0, xppartGetMass)(this); }
Real xparticles_lib::XParticle::GetSpeed() { XPLibCallR(0.0, xppartGetSpeed)(this); }
LONG xparticles_lib::XParticle::GetGroupID() { XPLibCallR(0, xppartGetGroupID)(this); }
LONG xparticles_lib::XParticle::GetID() { XPLibCallR(0, xppartGetID)(this); }
xparticles_lib::XPARTICLE_FLAGS xparticles_lib::XParticle::GetFlags() { XPLibCallR(xparticles_lib::XPARTICLE_FLAGS_0, xppartGetFlags)(this); }
Real xparticles_lib::XParticle::GetDensity() { XPLibCallR(0.0, xppartGetDensity)(this); }
LONG xparticles_lib::XParticle::GetDisplay() { XPLibCallR(0, xppartGetDisplay)(this); }
xparticles_lib::XPARTICLE_BITS xparticles_lib::XParticle::GetBits() { XPLibCallR(xparticles_lib::XPARTICLE_BITS_0, xppartGetBits)(this); }
Matrix xparticles_lib::XParticle::GetMatrix() { XPLibCallR(Matrix(), xppartGetMatrix)(this); }
Vector xparticles_lib::XParticle::GetRotation() { XPLibCallR(Vector(), xppartGetRotation)(this); }
Real xparticles_lib::XParticle::GetDistanceTravelled() { XPLibCallR(0.0, xppartGetDistanceTravelled)(this); }
Vector xparticles_lib::XParticle::GetSpin() { XPLibCallR(Vector(), xppartGetSpin)(this); }
BOOL xparticles_lib::XParticle::IsSpinEnabled() { XPLibCallR(FALSE, xppartIsSpinEnabled)(this); }
Real xparticles_lib::XParticle::GetTemperature() { XPLibCallR(0.0, xppartGetTemperature)(this); }
Real xparticles_lib::XParticle::GetFuel() { XPLibCallR(0.0, xppartGetFuel)(this); }
Real xparticles_lib::XParticle::GetFire() { XPLibCallR(0.0, xppartGetFire)(this); }
Real xparticles_lib::XParticle::GetSmoke() { XPLibCallR(0.0, xppartGetSmoke)(this); }
Real xparticles_lib::XParticle::GetExpansion() { XPLibCallR(0.0, xppartGetExpansion)(this); }
Vector xparticles_lib::XParticle::GetUVW() { XPLibCallR(Vector(), xppartGetUVW)(this); }

void xparticles_lib::XParticle::SetPosition(const Vector &p) { XPLibCall(xppartSetPosition)(this, p); }
void xparticles_lib::XParticle::SetVelocity(const Vector &v) { XPLibCall(xppartSetVelocity)(this, v); }
void xparticles_lib::XParticle::SetTime(Real time) { XPLibCall(xppartSetTime)(this, time); }
void xparticles_lib::XParticle::SetLife(Real life) { XPLibCall(xppartSetLife)(this, life); }
void xparticles_lib::XParticle::SetColor(const Vector &col) { XPLibCall(xppartSetColor)(this, col); }
void xparticles_lib::XParticle::SetRadius(Real r) { XPLibCall(xppartSetRadius)(this, r); }
void xparticles_lib::XParticle::SetMass(Real m) { XPLibCall(xppartSetMass)(this, m); }
void xparticles_lib::XParticle::SetSpeed(Real s) { XPLibCall(xppartSetSpeed)(this, s); }
void xparticles_lib::XParticle::SetGroupID(LONG id) { XPLibCall(xppartSetGroupID)(this, id); }
void xparticles_lib::XParticle::SetID(LONG id) { XPLibCall(xppartSetID)(this, id); }
void xparticles_lib::XParticle::SetFlags(xparticles_lib::XPARTICLE_FLAGS flags) { XPLibCall(xppartSetFlags)(this, flags); }
void xparticles_lib::XParticle::SetDensity(Real density) { XPLibCall(xppartSetDensity)(this, density); }
void xparticles_lib::XParticle::SetDisplay(LONG type) { XPLibCall(xppartSetDisplay)(this, type); }
void xparticles_lib::XParticle::SetBits(XPARTICLE_BITS bits) { XPLibCall(xppartSetBits)(this, bits); }
void xparticles_lib::XParticle::SetMatrix(const Matrix &m) { XPLibCall(xppartSetMatrix)(this, m); }
void xparticles_lib::XParticle::SetRotation(const Vector &rot) { XPLibCall(xppartSetRotation)(this, rot); }
void xparticles_lib::XParticle::SetDistanceTravelled(Real dist) { XPLibCall(xppartSetDistanceTravelled)(this, dist); }
void xparticles_lib::XParticle::SetSpin(const Vector &spin) { XPLibCall(xppartSetSpin)(this, spin); }
void xparticles_lib::XParticle::SetSpinEnabled(BOOL enable) { XPLibCall(xppartSetSpinEnabled)(this, enable); }
void xparticles_lib::XParticle::SetTemperature(Real temp) { XPLibCall(xppartSetTemperature)(this, temp); }
void xparticles_lib::XParticle::SetFuel(Real fuel) { XPLibCall(xppartSetFuel)(this, fuel); }
void xparticles_lib::XParticle::SetFire(Real fire) { XPLibCall(xppartSetFire)(this, fire); }
void xparticles_lib::XParticle::SetSmoke(Real smoke) { XPLibCall(xppartSetSmoke)(this, smoke); }
void xparticles_lib::XParticle::SetExpansion(Real expansion) { XPLibCall(xppartSetExpansion)(this, expansion); }
void xparticles_lib::XParticle::SetUVW(const Vector &uvw) { XPLibCall(xppartSetUVW)(this, uvw); }

LONG xparticles_lib::XParticle::GetIndex() { XPLibCallR(0, xppartGetIndex)(this); }
xparticles_lib::XParticle *xparticles_lib::XParticle::GetNext() { XPLibCallR(NULL, xppartGetNext)(this); }

LONG xparticles_lib::XParticle::AddCustomData(LONG id, const String &name, const GeData &data) { XPLibCallR(NOTOK, xppartAddCustomData)(this, id, name, data); }
void xparticles_lib::XParticle::SetCustomData(LONG index, const GeData &data) { XPLibCall(xppartSetCustomData)(this, index, data); }
GeData *xparticles_lib::XParticle::GetCustomData(LONG index, LONG *id, String *name) { XPLibCallR(NULL, xppartGetCustomData)(this, index, id, name); }
LONG xparticles_lib::XParticle::FindCustomData(LONG id, const String &name) { XPLibCallR(NOTOK, xppartFindCustomData)(this, id, name); }
LONG xparticles_lib::XParticle::GetCustomDataCount() { XPLibCallR(0, xppartGetCustomDataCount)(this); }
BOOL xparticles_lib::XParticle::RemoveCustomData(LONG index) { XPLibCallR(FALSE, xppartRemoveCustomData)(this, index); }

LONG xparticles_lib::XParticle::GetBirthConstraintsCount() { XPLibCallR(0, xppartGetBirthConstraintsCount)(this); }
LONG xparticles_lib::XParticle::GetDistanceConstraintsCount() { XPLibCallR(0, xppartGetDistanceConstraintsCount)(this); }
LONG xparticles_lib::XParticle::GetParticleConstraintsCount() { XPLibCallR(0, xppartGetParticleConstraintsCount)(this); }
LONG xparticles_lib::XParticle::GetColliderConstraintsCount() { XPLibCallR(0, xppartGetColliderConstraintsCount)(this); }

xparticles_lib::XParticleConstraint *xparticles_lib::XParticle::GetBirthConstraint(LONG index) { XPLibCallR(NULL, xppartGetBirthConstraint)(this, index); }
xparticles_lib::XParticleConstraint *xparticles_lib::XParticle::GetDistanceConstraint(LONG index) { XPLibCallR(NULL, xppartGetDistanceConstraint)(this, index); }
xparticles_lib::XParticleConstraint *xparticles_lib::XParticle::GetParticleConstraint(LONG index) { XPLibCallR(NULL, xppartGetParticleConstraint)(this, index); }
xparticles_lib::XParticleColliderConstraint *xparticles_lib::XParticle::GetColliderConstraint(LONG index) { XPLibCallR(NULL, xppartGetColliderConstraint)(this, index); }

xparticles_lib::XParticleConstraint *xparticles_lib::XParticle::AddBirthConstraint() { XPLibCallR(NULL, xppartAddBirthConstraint)(this); }
xparticles_lib::XParticleConstraint *xparticles_lib::XParticle::AddDistanceConstraint() { XPLibCallR(NULL, xppartAddDistanceConstraint)(this); }
xparticles_lib::XParticleConstraint *xparticles_lib::XParticle::AddParticleConstraint() { XPLibCallR(NULL, xppartAddParticleConstraint)(this); }
xparticles_lib::XParticleConstraint *xparticles_lib::XParticle::AddColliderConstraint() { XPLibCallR(NULL, xppartAddColliderConstraint)(this); }

void xparticles_lib::XParticle::RemoveBirthConstraint(LONG index) { XPLibCall(xppartRemoveBirthConstraint)(this, index); }
void xparticles_lib::XParticle::RemoveDistanceConstraint(LONG index) { XPLibCall(xppartRemoveDistanceConstraint)(this, index); }
void xparticles_lib::XParticle::RemoveParticleConstraint(LONG index) { XPLibCall(xppartRemoveParticleConstraint)(this, index); }
void xparticles_lib::XParticle::RemoveColliderConstraint(LONG index) { XPLibCall(xppartRemoveColliderConstraint)(this, index); }

Real XPMaterial::SampleSize(xparticles_lib::XParticle *xpParticle, const Vector &p, VolumeData *vd, XPVideoPost *render) { XPLibCallR(NULL, xpvpSampleSize)(this, xpParticle, p, vd, render); }
Vector XPMaterial::SampleColor(xparticles_lib::XParticle *xpParticle, const Vector &p, VolumeData *vd, XPVideoPost *render, Real radius) { XPLibCallR(Vector(), xpvpSampleColor)(this, xpParticle, p, vd, render, radius); }
Real XPMaterial::SampleTrans(xparticles_lib::XParticle *xpParticle, const Vector &p, VolumeData *vd, XPVideoPost *render, Real radius) { XPLibCallR(NULL, xpvpSampleTrans)(this, xpParticle, p, vd, render, radius); }

String XPGetVersion()
{
	XPLibCallR(String(), xpGetVersion)();
}

Real xparticles_lib::XParticleConstraint::GetLength() { XPLibCallR(0.0, xpconstraintGetLength)(this); }
LONG xparticles_lib::XParticleConstraint::GetIndex() { XPLibCallR(NOTOK, xpconstraintGetIndex)(this); }
LONG xparticles_lib::XParticleConstraint::GetFlags() { XPLibCallR(0, xpconstraintGetFlags)(this); }
LONG xparticles_lib::XParticleConstraint::GetID() { XPLibCallR(NOTOK, xpconstraintGetID)(this); }

void xparticles_lib::XParticleConstraint::SetLength(Real len) { XPLibCall(xpconstraintSetLength)(this, len); }
void xparticles_lib::XParticleConstraint::SetIndex(LONG index) { XPLibCall(xpconstraintSetLength)(this, index); }
void xparticles_lib::XParticleConstraint::SetFlags(LONG flags) { XPLibCall(xpconstraintSetLength)(this, flags); }
void xparticles_lib::XParticleConstraint::SetID(LONG id) { XPLibCall(xpconstraintSetLength)(this, id); }

Real xparticles_lib::XParticleColliderConstraint::GetLength() { XPLibCallR(0.0, xpcollconstraintGetLength)(this); }
LONG xparticles_lib::XParticleColliderConstraint::GetIndex() { XPLibCallR(NOTOK, xpcollconstraintGetIndex)(this); }
LONG xparticles_lib::XParticleColliderConstraint::GetFlags() { XPLibCallR(0, xpcollconstraintGetFlags)(this); }
LONG xparticles_lib::XParticleColliderConstraint::GetID() { XPLibCallR(NOTOK, xpcollconstraintGetID)(this); }
LULONG xparticles_lib::XParticleColliderConstraint::GetColliderID() { XPLibCallR(0, xpcollconstraintGetColliderID)(this); }
void xparticles_lib::XParticleColliderConstraint::GetPositionRS(Real &r, Real &s) { XPLibCall(xpcollconstraintGetPositionRS)(this, r, s); }
Vector xparticles_lib::XParticleColliderConstraint::GetLastPosition() { XPLibCallR(Vector(), xpcollconstraintGetLastPosition)(this); }

void xparticles_lib::XParticleColliderConstraint::SetLength(Real len) { XPLibCall(xpcollconstraintSetLength)(this, len); }
void xparticles_lib::XParticleColliderConstraint::SetIndex(LONG index) { XPLibCall(xpcollconstraintSetIndex)(this, index); }
void xparticles_lib::XParticleColliderConstraint::SetFlags(LONG flags) { XPLibCall(xpcollconstraintSetFlags)(this, flags); }
void xparticles_lib::XParticleColliderConstraint::SetID(LONG id) { XPLibCall(xpcollconstraintSetID)(this, id); }
void xparticles_lib::XParticleColliderConstraint::SetColliderID(LULONG id) { XPLibCall(xpcollconstraintSetColliderID)(this, id); }
void xparticles_lib::XParticleColliderConstraint::SetPositionRS(Real r, Real s) { XPLibCall(xpcollconstraintSetPositionRS)(this, r, s); }
void xparticles_lib::XParticleColliderConstraint::SetLastPosition(const Vector &pos) { XPLibCall(xpcollconstraintSetLastPosition)(this, pos); }

Vector xparticles_lib::MixRS(Real r, Real s, Real ra, Real rb, Real rc, Real rd, BOOL quad) { XPLibCallR(Vector(), xpMixRSreal)(r, s, ra, rb, rc, rd, quad); }
Vector xparticles_lib::MixRS(Real r, Real s, const Vector &va, const Vector &vb, const Vector &vc, const Vector &vd, BOOL quad) { XPLibCallR(Vector(), xpMixRSvector)(r, s, va, vb, vc, vd, quad); }
void xparticles_lib::GetRS(Real &r, Real &s, const Vector &p, const Vector &va, const Vector &vb, const Vector &vc, const Vector &vd, BOOL quad) { XPLibCall(xpGetRS)(r, s, p, va, vb, vc, vd, quad); }

XPEmitterObject *XPDomainObject::GetGasEmitter() { XPLibCallR(nullptr, xpdomainGetGasEmitter)(this); }
LLONG XPDomainObject::GetWidth() { XPLibCallR(0, xpdomainGetWidth)(this); }
LLONG XPDomainObject::GetHeight() { XPLibCallR(0, xpdomainGetHeight)(this); }
LLONG XPDomainObject::GetDepth() { XPLibCallR(0, xpdomainGetDepth)(this); }

void XPDomainObject::GetVoxelXYZ(const Vector &p, LLONG &x, LLONG &y, LLONG &z) { XPLibCall(xpdomainGetVoxelXYZ)(this, p, x, y, z); }
Vector XPDomainObject::GetVoxelCenter(LLONG x, LLONG y, LLONG z) { XPLibCallR(Vector(), xpdomainGetVoxelCenter)(this, x, y, z); }

Vector XPDomainObject::GetVelocity(const Vector &p) { XPLibCallR(Vector(), xpdomainGetVelocity)(this, p); }
Vector XPDomainObject::GetVelocity(LLONG x, LLONG y, LLONG z) { XPLibCallR(Vector(), xpdomainGetVelocityXYZ)(this, x, y, z); }
Real XPDomainObject::GetSmoke(const Vector &p) { XPLibCallR(0.0, xpdomainGetSmoke)(this, p); }
Real XPDomainObject::GetSmoke(LLONG x, LLONG y, LLONG z) { XPLibCallR(0.0, xpdomainGetSmokeXYZ)(this, x, y, z); }
Real XPDomainObject::GetFire(const Vector &p) { XPLibCallR(0.0, xpdomainGetFire)(this, p); }
Real XPDomainObject::GetFire(LLONG x, LLONG y, LLONG z) { XPLibCallR(0.0, xpdomainGetFireXYZ)(this, x, y, z); }
Real XPDomainObject::GetFuel(const Vector &p) { XPLibCallR(0.0, xpdomainGetFuel)(this, p); }
Real XPDomainObject::GetFuel(LLONG x, LLONG y, LLONG z) { XPLibCallR(0.0, xpdomainGetFuelXYZ)(this, x, y, z); }
Real XPDomainObject::GetTemperature(const Vector &p) { XPLibCallR(0.0, xpdomainGetTemperature)(this, p); }
Real XPDomainObject::GetTemperature(LLONG x, LLONG y, LLONG z) { XPLibCallR(0.0, xpdomainGetTemperatureXYZ)(this, x, y, z); }
Vector XPDomainObject::GetUVW(const Vector &p) { XPLibCallR(Vector(), xpdomainGetUVW)(this, p); }
Vector XPDomainObject::GetUVW(LLONG x, LLONG y, LLONG z) { XPLibCallR(Vector(), xpdomainGetUVWXYZ)(this, x, y, z); }
